Subject: bug#1085: 23.0.60; all-completions, try-completion inconsistent: Info-read-node-name-1

From: Stefan Monnier <[email-masked]>
Date: Sun, 05 Oct 2008 19:36:19 -0400

> Lisp code needs to be able to depend on the fact that the valid
> completions returned by `all-completions' have the common prefix
> that is returned by `try-completion' (which must in turn have the
> input as its prefix).

This fact has simply never been true in general.
It's true as long as the completion table is not a function, but
otherwise all bets are off.

In practice the main case where this "invariant" does not hold is when
the completion table is the one for file names, where all-completions
returns names that do not "full" (i.e. do not include the directory
name).  But other cases exist.

For code that needs to live with this problem (e.g. minibuffer.el),
Emacs-23 introduces a new way to call the completion table function with
a `boundary' argument.

        Stefan